<template>
    <v-container class="grey lighten-5">
        <v-row v-for="n in products"
            :key="n.product_code"
            cols="12"
            sm="4">
        <v-col>
            <v-card
                class="mx-auto"
                flat
            >
                <v-list-item three-line>
                <v-list-item-content>
                    <v-list-item-title class="headline mb-1">
                    {{n.product_code}}
                    </v-list-item-title>
                    <v-list-item-subtitle>{{n.product_description}} <br/> 
                        <span v-if="getPromotion(n) === undefined">{{n.price}} €</span>
                        <span v-else >
                            <del>{{n.price}} €</del>
                            <span v-if="getPromotion(n).offer_percentage !== null">
                                {{getPromotionPrice(n, getPromotion(n))}} €
                            </span>
                        </span>
                    </v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-avatar
                    tile
                    size="80"
                    color="grey"
                ></v-list-item-avatar>
                </v-list-item>

                <v-card-actions>
                <v-btn
                    outlined
                    rounded
                    text
                    v-on:click="() => {addCart(n)}"
                >
                    Add to Cart
                </v-btn>
                <div v-if="getQuantity(n.product_code) > 0">{{getQuantity(n.product_code)}}</div>
                <v-btn
                    outlined
                    rounded
                    text
                    v-if="getQuantity(n.product_code) > 0"
                    v-on:click="() => {removeCart(n)}"
                >
                    remove to Cart
                </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>
        </v-row>
    </v-container>
</template>

<script>
import axios from 'axios';
export default {
  name: 'Market',
  components: {
  },
  data: () => ({
      products: [],
      cart: [],
  }),
  mounted () {
    axios
      .get(process.env.VUE_APP_URL_E_COMMERCE + '/product')
      .then(response => (this.products = response.data));
    if (localStorage.cart) {
      this.cart = JSON.parse(localStorage.cart);
    }
  },
  methods: {
    addCart: function (product) {
        let dataId = this.cart.findIndex((value) => {
            return value.id === product.product_code;
        });

        if (dataId !== -1){
            let tmp = [...this.cart];
            tmp[dataId].quantity += 1; 
            this.cart = tmp;
        } else {
            const promotion = this.getPromotion(product);
            if (promotion) {
                this.cart.push({
                    quantity: 1, 
                    id: product.product_code, 
                    product: product, 
                    price: this.getPromotionPrice(product, promotion), 
                    promotion: promotion
                });
            } else {
                this.cart.push({
                    quantity: 1, 
                    id: product.product_code, 
                    product: product, 
                    price: product.price, 
                    promotion: undefined,
                });
            }
        }
    },
    removeCart: function (product) {
        let dataId = this.cart.findIndex((value) => {
            return value.id === product.product_code;
        });

        if (dataId !== -1){
            let tmp = [...this.cart];
            tmp[dataId].quantity -= 1; 
            if (tmp[dataId].quantity <= 0) {
                tmp.splice(dataId, 1);
            }
            this.cart = tmp;
        }
    },
    getQuantity: function (productId) {
        let product = this.cart.findIndex((value) => {
            return value.id === productId;
        });
        console.log("hello " + product)
        if (product != -1) {
            return this.cart[product].quantity;
        } else {
            return 0;
        }
    },
    setQuantity: function (product, quantity) {
        let dataId = this.cart.findIndex((value) => {
            return value.id === product.product_code;
        });

        if (dataId !== -1){
            let tmp = [...this.cart];
            tmp[dataId].quantity = quantity; 
            this.cart = tmp;
        } else {
            this.cart.push({quantity: 1, id: product.product_code, product: product});
        }
    },
    getSumPrice: function () {
        let sum = 0;
        this.cart.forEach(element => {
            sum += element.quantity * element.product.price;
        });
        return sum;
    },
    getPromotion: function (product){
        //const sumprice = this.getSumPrice();
        for (let promo in product.promotions) {
            if (product.promotions[promo].promotion) {
                const promotion = product.promotions[promo].promotion;
                const start = new Date(promotion.start_date);
                const end = new Date(promotion.end_date);
                if (start < Date.now() && end > Date.now()) { // Need check minimum amount 
                    return promotion;
                }
            }
        }
        return undefined;
    },
    getPromotionPrice: function (product, promotion) {
        if(promotion.offer_percentage !== null) {
            return (product.price -  (product.price * promotion.offer_percentage / 100)).toFixed(2);
        }
        if (promotion.offer_amount !== null) {
            return (product.price - promotion.offer_amount).toFixed(2);
        }
    }
},
watch: {
    cart: function () {
        console.log('setCart');
        localStorage.cart = JSON.stringify(this.cart);

    }
},
};
</script>
